#include "display.h"
#include "MonochromeLib.h"
#include "usefull.h"
#include "math.h"
#include "stdlib.h"

extern int _NOTIMER_;

void disp_Case(int x, int y, unsigned char typeCase){


	//Ordre de stockage des types de cases : D?EB12345678

	static const char tileSet[12][5] = {
		{0x30, 0x50, 0x30, 0x10, 0x78},
		{0x60, 0x10, 0x20, 0x00, 0x20},
		{0xA8, 0x70, 0xF8, 0x70, 0xA8},
		{0xA8, 0x50, 0x88, 0x50, 0xA8},
		{0x20, 0x60, 0x20, 0x20, 0x20},
		{0x70, 0x10, 0x70, 0x40, 0x70},
		{0x70, 0x10, 0x70, 0x10, 0x70},
		{0x50, 0x50, 0x70, 0x10, 0x10},
		{0x70, 0x40, 0x70, 0x10, 0x70},
		{0x70, 0x40, 0x70, 0x50, 0x70},
		{0x70, 0x10, 0x30, 0x10, 0x10},
		{0x70, 0x50, 0x70, 0x50, 0x70}};

	if(typeCase & CASE_DECOUVERTE){

		ML_rectangle(x, y, x+7, y+7, 0, ML_BLACK, ML_BLACK);

		if(typeCase==255) ML_bmp_xor_cl(tileSet[2], x+1, y+1, 5, 5);
		else if(typeCase & CASE_BOMBE) ML_bmp_xor_cl(tileSet[3], x+1, y+1, 5, 5);
		else if(typeCase%16) ML_bmp_xor_cl(tileSet[3+typeCase%16], x+1, y+1, 5, 5);}

	else{

		ML_rectangle(x, y, x+6, y+6, 0, ML_WHITE, ML_WHITE);
		ML_horizontal_line(y+7, x, x+7, ML_BLACK);
		ML_vertical_line(x+7, y, y+6, ML_BLACK);

		if(typeCase & CASE_DRAPEAU) ML_bmp_xor_cl(tileSet[0], x+1, y+1, 5, 5);
		if(typeCase & CASE_HYPOTHESE) ML_bmp_xor_cl(tileSet[1], x+1, y+1, 5, 5);}}


int loglol(int n){
	int lol = 0;
	if(n<=0) lol=1;
	while(n){
		lol++;
		n/=10;}
	return lol;}

void disp_Time(int sec){

	int n = loglol(sec);

	static const unsigned char s[4] = {64, 128, 64, 128};

	ML_rectangle(-1, -1, 12+4*n, 7, 1, ML_WHITE, ML_BLACK);
	PrintMini(1, 1, "t=", 2);
	PrintV(9, 1, sec, 2);
	ML_bmp_xor(s, 9+4*n, 2, 2, 4);}

void disp_Reste(int sec){

	int n = loglol(sec);

	ML_rectangle(-1, 56, 10+4*n, 64, 1, ML_WHITE, ML_BLACK);
	PrintMini(1, 58, "r=", 2);
	PrintV(10, 58, sec, 2);}


void disp_Map(int* info, int x, int y, unsigned char* map){

	int i, j;
	static const unsigned char bg[7] = { 238, 198, 146, 56, 146, 198, 238 };

	ML_clear_vram();
	for(i=0; i<128; i+=7) for(j=0; j<64; j+=7) ML_bmp_xor_cl(bg, i-x%7, j-y%7, 7, 7);

	for(i=-8; i<9; i++){
		if(x+i>-1 && x+i<info[2]){
			for(j=-4; j<5; j++){
				if(j+y>-1 && j+y<info[1]){
					disp_Case(60+8*i, 28+8*j, map[info[2]*(y+j)+x+i]);}}}}

	ML_vertical_line(59-8*x, 27-8*y, 27+8*(info[1]-y), ML_BLACK);
	ML_horizontal_line(27-8*y, 59-8*x, 59+8*(info[2]-x), ML_BLACK);
	ML_rectangle(58-8*x, 26-8*y, 60+8*(info[2]-x), 28+8*(info[1]-y), 1, ML_BLACK, ML_TRANSPARENT);
	ML_rectangle(57-8*x, 25-8*y, 61+8*(info[2]-x), 29+8*(info[1]-y), 1, ML_WHITE, ML_TRANSPARENT);

	ML_rectangle(59, 27, 67, 35, 1, ML_CHECKER, ML_TRANSPARENT);}

void anim_Boum(int* info, int x, int y, unsigned char* map){

	int i, j;

	disp_Map(info, x, y, map);
	disp_Time(info[0]/128);
	ML_display_vram();

	for(i=-8; i<9; i++){
		if(x+i>-1 && x+i<info[2]){
			for(j=-4; j<5; j++){
				if(j+y>-1 && j+y<info[1] && (map[info[2]*(y+j)+x+i] & CASE_BOMBE)){
					map[info[2]*(y+j)+x+i] |= CASE_DECOUVERTE;
					disp_Tout(info, x, y, map, info[0]);
					Sleep(50);}}}}

	Sleep(200);

	for(i=0; i<info[1]*info[2]; i++) if(map[i] & CASE_BOMBE) map[i] = 255;

	disp_Tout(info, x, y, map, info[0]);
	Sleep(400);}

void disp_MsgFin(){
	ML_horizontal_line(23, 0, 127, ML_WHITE);
	ML_horizontal_line(24, 0, 127, ML_BLACK);
	ML_horizontal_line(39, 0, 127, ML_BLACK);
	ML_horizontal_line(40, 0, 127, ML_WHITE);
	ML_rectangle(21, 25, 106, 38, 0, ML_BLACK, ML_BLACK);
	ML_rectangle(-2, 25, 20, 38, 2, ML_WHITE, ML_BLACK);
	ML_rectangle(107, 25, 129, 38, 2, ML_WHITE, ML_BLACK);}


void disp_Tout(int* info, int x, int y, unsigned char* map, int t){

	_NOTIMER_ = 1;

	disp_Map(info, x, y, map);// On affiche la map,
	disp_Time(t/128); // On affiche le temps coul,
	disp_Reste(info[4]);
	ML_display_vram(); // Et vole la gagure

	_NOTIMER_ = 0;

}

void disp_Highlight(int x, int y){

	static const unsigned char bombe[9] = {0x08, 0x49, 0x3E, 0x32, 0xFB, 0x3E, 0x3E, 0x49, 0x08};

	ML_rectangle(3, y, x, y+6, 0, ML_XOR, ML_XOR);
	ML_rectangle(9, y-2, 17, y+8, 0, ML_WHITE, ML_WHITE);
	ML_pixel(11, y-2, ML_XOR);
	ML_pixel(15, y-2, ML_XOR);
	ML_pixel(11, y+8, ML_XOR);
	ML_pixel(15, y+8, ML_XOR);
	ML_pixel(13, y-3, ML_XOR);
	ML_pixel(13, y+9, ML_XOR);
	ML_horizontal_line(y-1, 8, 18, ML_WHITE);
	ML_horizontal_line(y+7, 8, 18, ML_WHITE);
	ML_bmp_xor(bombe, 9, y-1, 8, 9);
	ML_pixel(17, y+3, ML_XOR);

	ML_display_vram();

	ML_bmp_xor(bombe, 9, y-1, 8, 9);
	ML_pixel(17, y+3, ML_XOR);
	ML_rectangle(3, y, x, y+6, 0, ML_XOR, ML_XOR);
	ML_rectangle(9, y-2, 17, y+8, 0, ML_BLACK, ML_BLACK);
	ML_pixel(13, y-3, ML_XOR);
	ML_pixel(13, y+9, ML_XOR);
	ML_horizontal_line(y-1, 8, 18, ML_BLACK);
	ML_horizontal_line(y+7, 8, 18, ML_BLACK);}

void disp_Pontilev(unsigned int d){

	const unsigned char pontilev[126] = { 0, 3, 55, 224, 0, 0, 0, 0, 0, 0, 243, 49, 143, 0, 0, 0, 0, 0, 1, 155, 49,
		134, 0, 8, 0, 0, 0, 249, 155, 177, 134, 96, 48, 0, 0, 51, 205, 155, 113, 134,
		96, 0, 0, 0, 51, 205, 155, 49, 134, 96, 252, 0, 31, 179, 205, 155, 49, 134,
		96, 205, 155, 217, 187, 249, 155, 49, 134, 96, 193, 153, 152, 55, 192, 240,
		0, 15, 96, 241, 153, 158, 51, 192, 0, 0, 0, 102, 193, 153, 152, 51, 192, 0,
		0, 0, 126, 193, 153, 152, 51, 0, 0, 0, 0, 0, 205, 153, 153, 128, 0, 0, 0, 0,
		0, 252, 241, 159, 128, 0, 0, 0, 0, 0, 0, 99, 192, 0 };

	double i;

	for(i=0; i<0.5; i+=0.01){
		ML_rectangle(0, 0, 127, 63, 0, ML_BLACK, ML_BLACK);
		disp_Star(63, 31, 70, 23, 7, i, ML_WHITE, 23);

		ML_bmp_xor(pontilev, 27, 26, 72, 14);
		if(i<0.25) ML_rectangle(27+70*i/0.25, 26, 98, 39, 0, ML_BLACK, ML_BLACK);
	
		ML_display_vram();
		Sleep(d);}}

void disp_Star(int x, int y, int d, int n, float s, float a, int c, int e){
	
	int i;

	if(e>n) e=n;
	
	for(i=0; i<e; i++){
		
		ML_line(x + d*cos(a + (float)i*2*PI/(float)n), y + d*sin(a + (float)i*2*PI/(float)n),
				x + d*cos(a + ((float)i + s)*2*PI/(float)n), y + d*sin(a + ((float)i + s)*2*PI/(float)n), c);}}







































